//Proirct BinomialHeap
//------------ Tiberiu Petrica 334CB --------

import java.util.*;
import java.io.*;
import java.lang.*;

class Nod {
	
	private Nod parent;
	private int key;
	private int degree;
	private Nod child;
	private Nod sibling;
	

	public Nod(){
		parent = null;
		key = 0;
		degree = 0;
		child = null;
		sibling = null;
	}


	public Nod (Nod n){
		this.parent = n.getParent();
		this.key = n.getKey();
		this.degree = n.getDegree();
		this.child = n.getChild();
		this.sibling = n.getSibling();
	}
	
	public void setParent (Nod p){
		parent = p;
	}
	
	public void setKey (int k){
		key = k;
	}
	
	public void setDegree (int d){
		degree = d;
	}
	
	public void setChild (Nod n){
		child = n;		
	}
	
	public void setSibling (Nod n){
		sibling = n;
	}
	
	public Nod getParent(){
		return parent;
	}
	
	public int getKey(){
		return key;
	}
	
	public int getDegree(){
		return degree;
	}
	
	public Nod getChild(){
		return child;
	}
	
	public Nod getSibling(){
		return sibling;
	}
}





interface MergeHeap{
		
		public abstract void hinsert(Nod n);
		public abstract Nod hminimum();
		public abstract Nod hextractMin();
		public abstract void hunion(MergeHeap H1); 

} 





class BinomialHeap implements MergeHeap{
	
	private Nod head;
	
	public BinomialHeap(){
		head = null;
	}
	
	public void setHead (Nod n){
		head = n;
	}
	
	public Nod getHead(){
		return head;
	}
	
	public void binomialLink (Nod y, Nod z){
		
		y.setParent(z);
		y.setSibling(z.getChild());
		z.setChild(y);
		z.setDegree(z.getDegree()+1);
	}
	
	public void binomialHeapMerge (BinomialHeap H1){
		
		Nod temp, temp1, aux;
		if (head!=null){
			if (H1.getHead().getDegree() < head.getDegree()){
				temp = head;
				head = H1.getHead();
				temp1 = head.getSibling();
				aux = head;
			}
			else {
				temp = head.getSibling();
				temp1 = H1.getHead();
				aux = head;
			}
			
			while(temp!=null && temp1!=null){
				if (temp1.getDegree() < temp.getDegree()){
					aux.setSibling(temp1);
					aux = aux.getSibling();
					temp1 = temp1.getSibling(); 
				}
				else {
					aux.setSibling(temp);
					aux = aux.getSibling();
					temp = temp.getSibling();
				}
			}
			
			while(temp!=null){
				aux.setSibling(temp);
				aux = aux.getSibling();
				temp = temp.getSibling();
			}
		
			while(temp1!=null){
				aux.setSibling(temp1);
				aux = aux.getSibling();
				temp1 = temp1.getSibling();
			}
		}
		else 
			head = H1.getHead();
				
	} 
	
	
	public void hunion(MergeHeap H1){
		
		binomialHeapMerge((BinomialHeap)H1);
		
		Nod prevx, x, nextx;
		prevx = null;
		x = head;
		nextx = x.getSibling();
		
		while (nextx!=null){
			if ((x.getDegree()!= nextx.getDegree()) || (nextx.getSibling()!=null && nextx.getSibling().getDegree() == x.getDegree())){
				prevx = x;
				x = nextx;
			}
			else{
				if (x.getKey()<=nextx.getKey()){
					x.setSibling(nextx.getSibling());
					binomialLink(nextx,x);
				} 
				else {
					if(prevx == null){
						head = nextx;
					}
					else prevx.setSibling(nextx);
					binomialLink(x,nextx);
					x = nextx;
				}
			}
			nextx = x.getSibling();
		}
		
	}
	
	public void hinsert(Nod x){
		BinomialHeap H1 = new BinomialHeap();
		x.setParent(null);
		x.setChild(null);
		x.setSibling(null);
		x.setDegree(0);
		H1.setHead(new Nod(x));
		hunion((MergeHeap)H1); 
	}

	public Nod hminimum(){
		Nod y = null;
		Nod x = head;
		int min = 100;
		
		while (x!= null){
			if (x.getKey()<min){
				min = x.getKey();
				y = x;
			}
			x = x.getSibling();
		}
		return y;
	}
	
	public Nod hextractMin(){
		
		
		Nod prevx,x,nextx,n,p=null;
		
		prevx = null;
		x = head;
		nextx = x.getSibling();
		Nod y = null;
		
		int min = 100;
		BinomialHeap H1 = new BinomialHeap();
				
		while (x!= null){
			if (x.getKey()<min){
				min = x.getKey();
				y = x;
				p = prevx;
										
			}
			prevx = x;
			x = x.getSibling();
		
			
		}
		if (p!=null){
			p.setSibling(y.getSibling());
			H1.setHead(y);
			H1.getHead().setSibling(null);

			
		}	
		else{ 
			if(head.getSibling()!=null){
				H1.setHead(head);
				H1.getHead().setSibling(null);
				head = head.getSibling();
			}
			else{ 
				head = null;
				H1.setHead(y);
			}	
		}	
		
		
		Nod temp = H1.getHead();
		Nod prevz,z,nextz;
		prevz = null;
		z = temp.getChild();
		nextz = z.getSibling();
		z.setParent(null);
		
		if (z!=null){
			while (nextz!=null){
				z.setSibling(prevz);
				z.setParent(null);
				prevz = z;
				z = nextz;
				nextz = nextz.getSibling();
			}
			z.setSibling(prevz);
			z.setParent(null);

			H1.setHead(z);
		
		}
		
		else{
			temp = null;
			H1.setHead(null);
		}
		
		
		hunion((MergeHeap)H1);	
		return y;
			
	}
	
	
	
	public void binomialHeapDecreaseKey (Nod x, int k){
		if (k > x.getKey())
			System.out.println("Eroare noua cheie este mai mare decat cea curenta");
		

		Nod y,z;
		int aux;	
		x.setKey(k);
		y = x;
		z = y.getParent();
		
		while (z != null && y.getKey() < z.getKey()){
			aux = y.getKey();
			y.setKey(z.getKey());
			z.setKey(aux);
			y = z;
			z = y.getParent();
		
		}
		   	
	}
	

	public void binomialHeapDelete (Nod x){
		binomialHeapDecreaseKey (x,-1);
		hextractMin();
	} 
	
	
}

